# coding: utf-8
# В Ruby тоже есть исключения

## Go-approach
def bad_method
  result = 'abc'
  return :ok, result
end
## Плюсы: вы явно думаете в коде над тем, что что-то могло пойти не так
## Минусы: объём проверок может быть слишком большим
## Особенности: в Ruby подход не применяется, хотя есть библиотеки, решающие данную задачу

## Классический подход в Ruby - выбрасывать исключения
require 'open-uri'
web_page = open('https://ya.ru')
output = File.open('index.html', 'w')
while line = web_page.gets
  output.puts line
end
output.close
