# coding: utf-8
# Выражения
## Почти все выражения, которые вы пишите, имеют значения
a = 54 + b = 10 + c = 0
p a, b, c

## Это полезно использовать с логическими выражениями
some = if true
         "Some"
         :true
         "Test"
       else
         :false
       end
p some

votes_cast = 15
puts case votes_cast
     when 0...10 then :skip
     when 10..50 then :better
     else :rave
     end

# Есть такой специальный блок begin end
puts begin
       abc = 15
       14 + 5 + abc
     end
puts abc


# Возвращение значений из методов
## Последнее выражение в методе является его значением
class PrettyPrinter
  def <<(info)
    print info, ' '
    self
  end
end
printer = PrettyPrinter.new
printer << 'Making' << 'it' << 'rain'
puts

class ImportantArray
  def initialize
    @array = []
  end
  def <<(data)
    @array << data
    # Возвращайте self или nil в методах, которые не должны возвращать ничего пользователю (сеттеры)
    # self
  end
  def to_s
    @array.join(',')
  end
end
imArray = ImportantArray.new
arr = imArray << 10
p arr
arr.pop
puts imArray

# Пожалуйста не переопределяйте математические операторы и операцию квадратные скобочки
class NumberMimic
  def initialize
    @num = 0
  end

  def +(other)
    puts "Summing #{@num} and #{other}"
    @num -= other
    self
  end

  def -(other)
    puts "Substracting #{@num} and #{other}"
    @num += other
    self
  end

  def to_s
    puts "Printing"
    @num.to_s
  end

  def [](index)

  end
end

test_num = NumberMimic.new
puts test_num + 10 - 5 + 6
